<?php
/*
* WPGear. Users Login Monitor
* functions.php
*/
	/* Request Get_WhoIs.
	----------------------------------------------------------------- */
	function UsersLoginMonitor_Get_WhoIs ($IP) {
		global $wp_version;
		 
		$CURL_Query = "http://ip-api.com/json/$IP";
		
		$CURL_Arg = array(
			'timeout'     => 5,
			'redirection' => 5,
			'httpversion' => '1.0',
			'user-agent'  => 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' ),
			'blocking'    => true,
			'headers'     => array(),
			'cookies'     => array(),
			'body'        => null,
			'compress'    => false,
			'decompress'  => true,
			'sslverify'   => false,
			'stream'      => false,
			'filename'    => null
		);
			
		$CURL_Answer = wp_remote_get ($CURL_Query, $CURL_Arg);

		if (is_wp_error ($CURL_Answer)) {
			$Error_Eessage = $CURL_Answer -> get_error_message();
			
			return null;
		} else {
			if ($CURL_Answer) {
				$CURL_Answer_Code 		= isset($CURL_Answer['response']['code']) ? $CURL_Answer['response']['code'] : 'N/A';
				$CURL_Answer_Message	= isset($CURL_Answer['response']['message']) ? $CURL_Answer['response']['message'] : 'N/A';
				$CURL_Response 			= isset($CURL_Answer['body']) ? $CURL_Answer['body'] : 'N/A';	
				
				return $CURL_Response;
			}						
		}		
	}

	/* Check Plugin Installed
	----------------------------------------------------------------- */		
	function UsersLoginMonitor_Check_Plugin_Installed($Plugin_Slug = null) {
		$Result = false;
		
		if ($Plugin_Slug) {
			if (! function_exists ('get_plugins')) {
				require_once ABSPATH . 'wp-admin/includes/plugin.php';
			}
			
			$Plugins = get_plugins();
			
			foreach ($Plugins as $Plugin) {
				$Plugin_TextDomain = $Plugin['TextDomain'];
				if ($Plugin_TextDomain == $Plugin_Slug) {
					$Result = true;
				}
			}			
		}	
		
		return $Result;
	}	