<?php
/*
* WPGear. Users Login Monitor
* options.php
*/
	
    if (!current_user_can('edit_dashboard')) {
        return;
    }	
	
	$Digest_Email_Error = false;
	
	$Action 					= isset($_REQUEST['action']) ? sanitize_text_field ($_REQUEST['action']) : null;
	$New_Dashboard_LastLogin 	= (isset($_REQUEST['dashboard_lastlogin_users']) && $_REQUEST['dashboard_lastlogin_users'] != '') ? sanitize_text_field ($_REQUEST['dashboard_lastlogin_users']) : 10;
	$New_Digest_Enable 			= (isset($_REQUEST['digest_enable'])) ? 1 : 0;
	$New_Digest_Email 			= (isset($_REQUEST['digest_email']) && $_REQUEST['digest_email'] != '') ? sanitize_email ($_REQUEST['digest_email']) : get_option('admin_email');
	
	if ($Action == 'Update') {
		if ($New_Dashboard_LastLogin != $UsersLoginMonitor_Dashboard_LastLogin) {
			$UsersLoginMonitor_Dashboard_LastLogin = $New_Dashboard_LastLogin;
			update_option('ulm_dashboard_lastlogin', $UsersLoginMonitor_Dashboard_LastLogin);
		}		
		
		if ($New_Digest_Enable != $UsersLoginMonitor_Digest_Enable) {
			$UsersLoginMonitor_Digest_Enable = $New_Digest_Enable;
			update_option('ulm_digest', $UsersLoginMonitor_Digest_Enable);
		}	

		if ($New_Digest_Email != $UsersLoginMonitor_Digest_Email) {
			if (filter_var($New_Digest_Email, FILTER_VALIDATE_EMAIL)) {
				$UsersLoginMonitor_Digest_Email = $New_Digest_Email;
				update_option('ulm_email', $UsersLoginMonitor_Digest_Email);		
			} else {
				$Digest_Email_Error = "! Invalid email: $New_Digest_Email";
			}			
		}			
	}	
?>
	<div class="wrap">
		<h2>Users Login Monitor.</h2>
		<hr>	
		
		<div class="ulm_options_box">
			<form name="form_ULM_Options" method="post" style="margin-top: 20px;">
				<div style="margin-top: 10px; margin-left: 38px;">
					<label for="dashboard_lastlogin_users" title="How many Last Login Users to display in the console widget">Number of last login users-list in the widget: </label>
					<input id="dashboard_lastlogin_users" name="dashboard_lastlogin_users" type="text" style="width: 40px; text-align: center;" value="<?php echo $UsersLoginMonitor_Dashboard_LastLogin; ?>">
				</div>		

				<div style="margin-top: 10px; margin-left: 38px;">
					<label for="digest_enable" title="Daily-digest notifications On/Off">Daily-digest notifications: </label>
					<input id="digest_enable" name="digest_enable" type="checkbox" <?php if($UsersLoginMonitor_Digest_Enable) {echo 'checked';} ?>>
				</div>

				<div style="margin-top: 10px; margin-left: 38px;">
					<label for="digest_email" <?php if(!$UsersLoginMonitor_Digest_Enable) {echo 'style="color: darkgrey;"';} ?> title="Who will receive daily notifications?">E-mail for daily-digest notifications: </label>
					<input id="digest_email" name="digest_email" type="text" style="width: 250px;" value="<?php echo $UsersLoginMonitor_Digest_Email; ?>">
					<div id="digest_email_note" style="color: red;"><?php if($Digest_Email_Error) {echo $Digest_Email_Error ;} ?></div>
				</div>				

				<div style="margin-top: 10px; margin-bottom: 5px; text-align: right;">
					<span id="save_options_processing" style="display: none; margin-right: 5px;">
						<i class="fa fa-refresh fa-spin fa-fw fa-2x" aria-hidden="true" style="vertical-align: baseline;"></i>
					</span>
					<input id="btn_options_save" type="submit" class="button button-primary" style="margin-right: 5px;" value="Save">
				</div>
				<input id="action" name="action" type="hidden" value="Update">
			</form>
		</div>		
	</DIV>